package  
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	/**
	 * ...
	 * @author Mousman
	 */
	public class FileLoaderCmd extends ACommand
	{
		protected var _url:String;
		protected var _fileLoader:URLLoader;		
		
		public function FileLoaderCmd(url:String) 
		{
			_url = url;
		}
		
		override public function execute():void {
			var request:URLRequest = new URLRequest(_url);
			_fileLoader = new URLLoader();
			_fileLoader.dataFormat = URLLoaderDataFormat.BINARY;
			_fileLoader.addEventListener(Event.COMPLETE,	onCommandComplete);
			_fileLoader.addEventListener(ProgressEvent.PROGRESS,	onProgress);
			_fileLoader.addEventListener(IOErrorEvent.IO_ERROR, onIOError);
			_fileLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, onSecurityError);
			_fileLoader.load(request);
		}
		
		private function onSecurityError(e:SecurityErrorEvent):void 
		{
			trace("FileLoader onIOError :: url=\"" + _url + "\"" + " error : " + e.text);
			dispatchEvent(e);				
		}
		
		private function onProgress(e:ProgressEvent):void {
			dispatchEvent(e);
		}
		
		private function onIOError(e:IOErrorEvent):void {
			trace("FileLoaderCmd onIOError :: url=\"" + _url + "\"" + " error : " + e.text);
			dispatchEvent(e);			
		}
		
		public function get bytesLoaded():Number { return (_fileLoader != null)? _fileLoader.bytesLoaded : 0; }
				
		private function onCommandComplete(event:Event = null):void {
			var data:ByteArray = _fileLoader.data;
			dispatchEvent(new CommandEvent(CommandEvent.COMPLETE,data));
		}
	}
}