package 
{
	import flash.display.Sprite;
	import flash.events.ErrorEvent;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.utils.CompressionAlgorithm;
	
	/**
	 * ...
	 * @author Moussa Dembélé (www.mousman.com)
	 */
	public class Main extends Sprite 
	{
		private var _world:World;
		private var _texturesTab:Vector.<Object>;
		
		//----------------------------------------------------------------------------------------------
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		//----------------------------------------------------------------------------------------------
		//----------------------------------------------------------------------------------------------
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			var loader:URLLoader = new URLLoader();
			var adresse:URLRequest = new URLRequest("xml/textures.xml");
			loader.addEventListener(Event.COMPLETE,xmlTexturesLoaded);
			loader.addEventListener(ProgressEvent.PROGRESS,onProgress);
			loader.addEventListener(IOErrorEvent.IO_ERROR,onError);
			loader.addEventListener(ErrorEvent.ERROR, onError);			
			loader.load(adresse);
		}
		//----------------------------------------------------------------------------------------------
		//----------------------------------------------------------------------------------------------
		private function onProgress(event:Event):void {
			// hum
		}
		private function onError(event:Event):void {
			// hum
		}
		//----------------------------------------------------------------------------------------------
		//----------------------------------------------------------------------------------------------
		private function xmlTexturesLoaded(e:Event):void 
		{
			var xmlTextures:XML = new XML(e.target.data);
			var cmds:SequentialCommand = new SequentialCommand();
			var tObj:Object;
			var i:int = 0;
			
			_texturesTab = new Vector.<Object>(xmlTextures.textures.texture.length(),true);

			for each (var texture:XML in xmlTextures.textures.texture) {
				tObj = { id:texture.@id.toString(),width:int(texture.@width),height:texture.@height };
				_texturesTab[i]=tObj;
				var cmd:FileLoaderCmd = new FileLoaderCmd(texture.@file.toString());
				cmds.add(cmd);
				i++;
			}
			
			cmds.addEventListener(CommandEvent.COMPLETE, texturesLoaded);
			cmds.execute();
		}
		//----------------------------------------------------------------------------------------------
		//----------------------------------------------------------------------------------------------
		private function texturesLoaded(e:CommandEvent):void 
		{
			var textureFiles:Array = e.data as Array;
			
			for (var i:int; i < textureFiles.length; i++) {
				var textureBA:ByteArray = textureFiles[i] as ByteArray;
				textureBA.uncompress(CompressionAlgorithm.LZMA);
				_texturesTab[i].atfFile = textureBA;
			}
			
			_world = new World(stage,_texturesTab);
			addChild(_world);			
		}
		
	}
	
}