package 
{
	import flash.events.EventDispatcher;
	import flash.events.ProgressEvent;

	/**
	 * ...
	 * @author Mousman
	 */
		
	public class SequentialCommand extends EventDispatcher {
	
		private var commandList:Array;
		private var commandDatas:Array;
		private var index:int;
		private var bytesLoaded:int = 0;
		
		public function SequentialCommand(){
			commandList = [];
			commandDatas = [];
		}
		
		public function add(command:ACommand):void {
			command.addEventListener(CommandEvent.COMPLETE, commandComplete);
			command.addEventListener(CommandEvent.ERROR, commandError);
			commandList.push(command);
		}
		
		public function execute():void {
			index = 0;
			bytesLoaded = 0;
			nextCommand();
		}
		
		private function nextCommand():void {
			if (index >= commandList.length) {
				dispatchEvent(new CommandEvent(CommandEvent.COMPLETE,commandDatas));
			} 
			else {
				var cmd:ACommand = commandList[index] as ACommand;
				index++;
				cmd.execute();
			}		
		}

		private function commandComplete(event:CommandEvent):void {
			commandDatas.push(event.data);	
			bytesLoaded ++;
			nextCommand();
		}

		private function commandError(event:CommandEvent):void {
			dispatchEvent(new CommandEvent(CommandEvent.ERROR, event.data));
			nextCommand();
		}
		
		private function destroy():void {
			var cmd:ACommand;
			var length:int = commandDatas.length;
			for (var i:int = 0; i < length; i++) {
				cmd = commandList[i] as ACommand;
				cmd.removeEventListener(CommandEvent.COMPLETE, commandComplete);
				cmd.removeEventListener(CommandEvent.ERROR, commandError);
			}
			commandList = null;
			commandDatas = null;
		}
	
	}	
}