/*Copyright (c) 2012 Moussa Dembélé (www.mousman.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package com.mousman.as3.agal.parser.objs 
{
	/**
	* contains all datas for a mesh and is the representation of a  .obj and .mtl (wavefront) file :
	* A MObjMesh is composed of several MObject3D.
	* 
	* @author Moussa Dembélé (www.mousman.com)
	*/
	public class MObjMesh 
	{
		
		/**
		 * @private
		 */			
		private var _mObjects:Vector.<MObject3D>;
		/**
		 * @private
		 */			
		private var _nbVertices:uint;
		
		/**
		* Constructor. Creates a new MObjMesh instance.
		*/			
		public function MObjMesh() 
		{
			_mObjects = new Vector.<MObject3D>();
		}
		//----------------------------------------------------------------------------------------------	
		/**
		*
		* <p>add a Mobject3D to the mesh</p>
		* 
		* @param mObject : MObject3D.<p>an instance of MObject3D to be added to the mesh</p>
		*/		
		//----------------------------------------------------------------------------------------------		
		public function add(mObject:MObject3D):void
		{
			_mObjects.push(mObject);
		}	
		//----------------------------------------------------------------------------------------------		
		//----------------------------------------------------------------------------------------------		
		public function destroy():void {
			for each(var obj:MObject3D in _mObjects) {
				obj.destroy();
			}
			_mObjects = null;
		}		
		//----------------------------------------------------------------------------------------------		
		//----------------------------------------------------------------------------------------------		
		/**
		* Vector of MObject3D
		*/ 			
		public function set mObjects(vec:Vector.<MObject3D>):void{_mObjects = vec;}
		public function get mObjects():Vector.<MObject3D> {return _mObjects;}

		/**
		* Number of vertices in a mesh instance
		*/ 			
		public function set nbVertices(value:uint):void {_nbVertices = value;}
		public function get nbVertices():uint {return _nbVertices;}
	}

}