/*Copyright (c) 2012 Moussa Dembélé (www.mousman.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package com.mousman.as3.agal.parser.objs 
{
	import flash.display3D.textures.Texture;
	/**
	 * a Texture linked to an ID
	 * @author Moussa Dembélé (www.mousman.com)
	 */
	public class MTexture 
	{
		
		/**
		 * @private
		 */			
		private var _texture:Texture;
		/**
		 * @private
		 */			
		private var _id:String;
		
		
		/**
		* Constructor. Creates a new MTexture instance.
		*
		* @param id : String.<p>Id of an instance of MTexture</p>
		* @param texture : Texture.<p>Texture contained in an instance of MTexture</p>
		*/		
		public function MTexture(id:String,texture:Texture) 
		{
			_id = id;
			_texture = texture;
		}
		
		/**
		* Texture contained in an instance of MTexture
		*/		
		public function get texture():Texture 
		{
			return _texture;
		}
		
		/**
		* Id of an instance of MTexture
		*/		
		public function get id():String 
		{
			return _id;
		}
		
	}

}