/*Copyright (c) 2012 Moussa Dembélé (www.mousman.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package com.mousman.as3.agal.parser.shaders
{
	/**
	 * Store ShaderSet
	 * @author Moussa Dembélé (www.mousman.com)
	 */
	public class ShaderStore 
	{
		private var _shaderSetArray:Array = [];
		
		/**
		* Constructor. Creates a new ShaderStore instance.
		*
		*/	
		public function ShaderStore() 
		{
		}
		//----------------------------------------------------------------------------------------------	
		/**
		* Add a ShaderSet
		*
		* @param shaderSet : ShaderSet
		*/			
		//----------------------------------------------------------------------------------------------		
		public function add(shaderSet:ShaderSet):void {
			_shaderSetArray[shaderSet.id] = shaderSet;
		}
		//----------------------------------------------------------------------------------------------
		/**
		* Return a ShaderSet
		*
		* 
		* @param id : String.<p>Id of the ShaderSet to be returned</p>
		* 
		* @return the shaderSet
		*/			
		//----------------------------------------------------------------------------------------------		
		public function getShaderById(id:String):ShaderSet {
			return _shaderSetArray[id] as ShaderSet;
		}
		//----------------------------------------------------------------------------------------------	
		/**
		* Return all the ShaderSet contained in the ShaderStore
		*
		* 
		* @return all the shaderSet
		*/			
		//----------------------------------------------------------------------------------------------		
		public function get shaderSetArray():Array 
		{
			return _shaderSetArray;
		}
		//----------------------------------------------------------------------------------------------		
		//----------------------------------------------------------------------------------------------		
		public function destroy():void {
			for each(var shaderSet:ShaderSet in _shaderSetArray) {
				shaderSet.destroy();
			}
			_shaderSetArray = null;
		}		
		
	}

}