/*Copyright (c) 2012 Moussa Dembélé (www.mousman.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package com.mousman.as3.agal.parser.verticeswriter 
{
	/**
	 * WriterSet contains an Id , a IMBytesArrayWriter and the dataPerVertex used for the writer
	 * @author Moussa Dembélé (www.mousman.com)
	 */
	public class WriterSet 
	{
		
		private var _id:String;
		private var _writer:IMBytesArrayWriter;
		private var  _dataPerVertex:int;
		
		/**
		* Constructor. Creates a new WriterSet instance.
		*
		* @param id : String.<p>Id of the WriterSet instance.</p>
		* @param writer : IMBytesArrayWriter.
		* @param dataPerVertex : int.s
		*/			
		public function WriterSet(id:String,writer:IMBytesArrayWriter,dataPerVertex:int) 
		{
			_id = id;
			_writer = writer;		
			_dataPerVertex = dataPerVertex;
		}
		//----------------------------------------------------------------------------------------------		
		//----------------------------------------------------------------------------------------------		
		public function destroy():void {
			_writer.destroy();
			_writer = null;
		}			
		/**
		* IMBytesArrayWriter
		*/				
		public function get writer():IMBytesArrayWriter {return _writer;}
		public function set writer(value:IMBytesArrayWriter):void { _writer = value; }
		
		/**
		* id of the WriterSet instance
		*/			
		public function get id():String {return _id;}		
		
		/**
		* dataPerVertex used for the writer
		*/		
		public function get dataPerVertex():int {return _dataPerVertex;}
	}

}