/*Copyright (c) 2012 Moussa Dembélé (www.mousman.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package com.mousman.as3.agal.parser.verticeswriter 
{
	/**
	 * Contains all the WriterSet
	 * @author Moussa Dembélé (www.mousman.com)
	 */
	public class WriterStore 
	{
		private var _writerSetArray:Array = [];

		/**
		* Constructor. Creates a new WriterStore instance.
		*/			
		public function WriterStore() {
			
		}
		//----------------------------------------------------------------------------------------------	
		/**
		* add a WriterSet
		* @param writerSet : WriterSet.
		*/				
		//----------------------------------------------------------------------------------------------		
		public function add(writerSet:WriterSet):void {
			_writerSetArray[writerSet.id] = writerSet;
		}
		//----------------------------------------------------------------------------------------------	
		/**
		* Return of WriterSet defined by its Id.
		* @param id : String.<p>Id of the WriterSet wanted</p>
		* @return a WriterSet
		*/ 		
		//----------------------------------------------------------------------------------------------		
		public function getWriterById(id:String):WriterSet {
			return _writerSetArray[id] as WriterSet;
		}
		//----------------------------------------------------------------------------------------------	
		/**
		* Return all the WriterSet contained the the WriterStore instance
		* @return a Array of WriterSet
		*/ 			
		//----------------------------------------------------------------------------------------------		
		public function get writerSetArray():Array
		{
			return _writerSetArray;
		}
		//----------------------------------------------------------------------------------------------		
		//----------------------------------------------------------------------------------------------		
		public function destroy():void {
			for each(var writerSet:WriterSet in _writerSetArray) {
				writerSet.destroy();
			}
			_writerSetArray = null;
		}			
	}

}